﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace Cbcye.Client
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                InvocateDuplexCalculator();
            }
            catch (Exception exp)
            {
                Console.WriteLine("[Error] " + exp.Message);
            }

            Console.Read();
        }

        static void InvocateDuplexCalculator()
        {
            CalculatorCallbackHandler callbackHandler = new CalculatorCallbackHandler();

            using (ClientProxy calculator = new ClientProxy(new InstanceContext(callbackHandler)))
            {
                Console.WriteLine("Begin to invocate duplex calculator... ...");
                calculator.Add(85, 86);
                calculator.Close();
            }
        }
    }
}
