﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Description;
using Cbcye.Contract;
using Cbcye.Service;


namespace Cbcye.ServiceConsoleHost
{
    class Program
    {
        static void Main(string[] args)
        {
            HostCalculatorService();
        }

        static void HostCalculatorService()
        {
            Uri dualUri = new Uri("http://localhost:7788/cbcye/Calculator");
            //向HOST中添加BaseAddress
            using (ServiceHost calculatorServiceHost = new ServiceHost(typeof(DuplexCalculatorService), dualUri))
            {
                //WSDualHttpBinding适用于双工服务协定或通过 SOAP 媒介进行的通信。
                WSDualHttpBinding wsDualHttpBinding = new WSDualHttpBinding();
                //添加服务绑定和服务契约
                calculatorServiceHost.AddServiceEndpoint(typeof(IDuplexCalculator), wsDualHttpBinding, string.Empty);

                //绑定服务行为
                ServiceMetadataBehavior behavior = calculatorServiceHost.Description.Behaviors.Find<ServiceMetadataBehavior>();
                {
                    if (behavior == null)
                    {
                        behavior = new ServiceMetadataBehavior();
                        behavior.HttpGetEnabled = true;
                        calculatorServiceHost.Description.Behaviors.Add(behavior);
                    }
                    else
                    {
                        behavior.HttpGetEnabled = true;
                    }
                }

                //启动事件
                calculatorServiceHost.Opened += delegate
                {
                    Console.WriteLine("Calculator Service has begun to listen ... ... on "+ dualUri.ToString());
                };

                calculatorServiceHost.Open();
                Console.Read();
            }
        }
    }
}
